Summary:	General-purpose scalable concurrent malloc implementation
Summary(pl.UTF-8):	Ogólnego przeznaczenia, skalowalna, współbieżna implementacja funkcji malloc
Name:		jemalloc
Version:	5.2.0
Release:	2
License:	BSD
Group:		Libraries
#Source0Download: https://github.com/jemalloc/jemalloc/releases
Source0:	https://github.com/jemalloc/jemalloc/releases/download/%{version}/%{name}-%{version}.tar.bz2
# Source0-md5:	0af300de702a1443e6560c1eae254df7
Patch0:		%{name}-x32.patch
URL:		http://jemalloc.net/
BuildRequires:	libxslt-progs
BuildRequires:	sed >= 4.0
# list from include/jemalloc/internal/jemalloc_internal.h.in
# https://github.com/jemalloc/jemalloc/blob/3.6.0/include/jemalloc/internal/jemalloc_internal.h.in#L239
ExclusiveArch:	%{ix86} %{x8664} x32 alpha %{arm} aarch64 hppa ia64 le32 mips or1k ppc riscv s390 s390x sh4 sparcv9 sparc64 tile
# broken for us
# alpha: Missing implementation for 64-bit atomic operations"
# alpha: Missing implementation for 32-bit atomic operations"
ExcludeArch:	alpha
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
General-purpose scalable concurrent malloc(3) implementation. This
distribution is the stand-alone "portable" implementation of jemalloc.

%description -l pl.UTF-8
Ogólnego przeznaczenia, skalowalna, współbieżna implementacja funkcji
malloc(3). Ten pakiet zawiera samodzielną "przenośną" implementację
jemalloc.

%package devel
Summary:	Development files for jemalloc
Summary(pl.UTF-8):	Pliki programistyczne biblioteki jemalloc
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
This package contains the header files for developing applications
that use jemalloc library.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe do tworzenia aplikacji
wykorzystujących bibliotekę jemalloc.

%package static
Summary:	Static jemalloc library
Summary(pl.UTF-8):	Statyczna biblioteka jemalloc
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static jemalloc library.

%description static -l pl.UTF-8
Statyczna biblioteka jemalloc.

%prep
%setup -q
%patch0 -p1

# This is truncated during build. Seems interesting to save.
cp -p VERSION version

%{__sed} -i '1s, /usr/bin/env perl,%{__perl},' bin/jeprof.in

%build
# enable GNU+C99 standard (C99 for restrict keyword, GNU for asm)
CFLAGS="%{rpmcflags} -std=gnu99"
%configure \
	--with-jemalloc-prefix=je_

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# restore
cp -pf version VERSION

# soname improperly made, use fake main name (just use our current version)
%{__mv} $RPM_BUILD_ROOT%{_libdir}/libjemalloc.so.{2,%{version}}
ln -s $(basename $RPM_BUILD_ROOT%{_libdir}/libjemalloc.so.*.*.*) \
	$RPM_BUILD_ROOT%{_libdir}/libjemalloc.so.2

# Install this with doc macro instead
%{__rm} $RPM_BUILD_ROOT%{_docdir}/%{name}/jemalloc.html

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc COPYING README VERSION doc/jemalloc.html
%attr(755,root,root) %{_bindir}/jemalloc.sh
%attr(755,root,root) %{_libdir}/libjemalloc.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libjemalloc.so.2

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/jemalloc-config
%attr(755,root,root) %{_bindir}/jeprof
%attr(755,root,root) %{_libdir}/libjemalloc.so
%{_includedir}/jemalloc
%{_pkgconfigdir}/jemalloc.pc
%{_mandir}/man3/jemalloc.3*

%files static
%defattr(644,root,root,755)
%{_libdir}/libjemalloc.a
%{_libdir}/libjemalloc_pic.a
%changelog
* Sun Apr 28 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/jemalloc.git;a=log;h=master

* Sun Apr 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 43a0545
- added x32 patch (fix invalid operand size of bsrq instruction); release 2

* Sun Apr 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 2e057ca
- new URLs, updated to 5.2.0

* Fri Sep 16 2016 Jakub Bogusz <qboosh@pld-linux.org> 3d6933e
- updated to 4.2.1

* Wed May 11 2016 Jakub Bogusz <qboosh@pld-linux.org> d6e7429
- updated to 4.1.1

* Fri Apr 08 2016 Jakub Bogusz <qboosh@pld-linux.org> aa2a117
- updated to 4.1.0 (note: new soname)
- removed outdated no_pprof patch, now modified version of pprof called jeprof is included

* Tue Mar 03 2015 Elan Ruusamäe <glen@delfi.ee> 18f4e01
- x32 rebuild
- release 3 (by relup.sh)

* Mon Mar 02 2015 Elan Ruusamäe <glen@delfi.ee> e909dd8
- add x32 to supported archs, seems to build

* Fri Apr 04 2014 Jakub Bogusz <qboosh@pld-linux.org> c9ccfa6
- updated to 3.6.0

* Thu Feb 27 2014 Jakub Bogusz <qboosh@pld-linux.org> de9a3cb
- updated to 3.5.1

* Mon Jan 27 2014 Jakub Bogusz <qboosh@pld-linux.org> 6acf1e0
- updated to 3.5.0

* Sat Oct 26 2013 Jakub Bogusz <qboosh@pld-linux.org> b90f032
- updated to 3.4.1

* Sat Jun 08 2013 Jakub Bogusz <qboosh@pld-linux.org> b11c9f8
- updated to 3.4.0

* Fri Mar 08 2013 Jakub Bogusz <qboosh@pld-linux.org> 433c2fb
- updated to 3.3.1

* Sat Jan 26 2013 Jakub Bogusz <qboosh@pld-linux.org> ca009ba
- updated to 3.3.0

* Tue Nov 13 2012 Jakub Bogusz <qboosh@pld-linux.org> 5e021f0
- updated to 3.2.0

* Thu Nov 01 2012 Jakub Bogusz <qboosh@pld-linux.org> 769e7c9
- updated to 3.1.0

* Wed May 23 2012 Jakub Bogusz <qboosh@pld-linux.org> baca478
- updated to 3.0.0
- updated no_pprof patch

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> 48ca5e4
- rel 3
- reenable prefix, redis _requires_ it (see redis src/Makefile)

* Mon Dec 12 2011 Elan Ruusamäe <glen@pld-linux.org> e470056
- blah, no prefix system wide; redis needs patched otherwise

* Sat Nov 26 2011 Jakub Bogusz <qboosh@pld-linux.org> 6717edc
- updated to 2.2.5

